.586
.model flat, stdcall
	option casemap:none
	include	\masm32\include\windows.inc
	include	\masm32\include\timers.asm
	include	\masm32\macros\macros.asm
	
	include		 \masm32\include\masm32.inc
	includelib	 \masm32\include\masm32.lib

	include		 \masm32\include\kernel32.inc
	includelib	 \masm32\include\kernel32.lib
	
.data
	str1 db 32 dup (0)

.code

dw2binstr	proc
	;Value  - EAX
	;Buffer - EBX
	mov		edx, eax	;EDX holds the value
	mov		ecx, 8		;Bits per byte
	@@:
		mov		eax, edx
		and		eax, 01010101h			;Filters the low bit of every byte 
		or		eax, 30303030h			;ASCII convertion
		mov		byte ptr [ebx+31], al	;Placing the bytes into the buffer
		mov		byte ptr [ebx+23], ah
		ror		eax, 16
		mov		byte ptr [ebx+15], al
		mov		byte ptr [ebx+07], ah
		dec		ebx						;Going backwards
		ror		edx, 1					;Setting the next set of bits
		dec		ecx						;Loop back
		jnz		@B
	retn
dw2binstr	endp

start:
		push	ebp
		mov		ebp,esp
			counter_begin 100000h,HIGH_PRIORITY_CLASS
				mov		eax,00010010001101001010101111001101b ;1234ABCDh
				mov		ebx,offset str1
				invoke	dw2binstr
			counter_end
			print str$(eax), " Cycles"
			invoke	Sleep,3000
			xor		eax,eax
		pop		ebp
		retn
end start